/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.Objects;

/**
 * HarvestSourceValidation
 */

public class HarvestSourceValidation {
  @JsonProperty("by")
  private Object by = null;

  @JsonProperty("comment")
  private String comment = null;

  @JsonProperty("on")
  private LocalDateTime on = null;

  /**
   * Is it validated or not
   */
  public enum StateEnum {
    PENDING("pending"),
    
    ACCEPTED("accepted"),
    
    REFUSED("refused");

    private String value;

    StateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StateEnum fromValue(String text) {
      for (StateEnum b : StateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("state")
  private StateEnum state = null;

  public HarvestSourceValidation by(Object by) {
    this.by = by;
    return this;
  }

   /**
   * Who performed the validation
   * @return by
  **/
  @ApiModelProperty(value = "Who performed the validation")
  public Object getBy() {
    return by;
  }

  public void setBy(Object by) {
    this.by = by;
  }

  public HarvestSourceValidation comment(String comment) {
    this.comment = comment;
    return this;
  }

   /**
   * A comment about the validation. Required on rejection
   * @return comment
  **/
  @ApiModelProperty(value = "A comment about the validation. Required on rejection")
  public String getComment() {
    return comment;
  }

  public void setComment(String comment) {
    this.comment = comment;
  }

   /**
   * Date date on which validation was performed
   * @return on
  **/
  @ApiModelProperty(value = "Date date on which validation was performed")
  public LocalDateTime getOn() {
    return on;
  }

  public HarvestSourceValidation state(StateEnum state) {
    this.state = state;
    return this;
  }

   /**
   * Is it validated or not
   * @return state
  **/
  @ApiModelProperty(example = "pending", required = true, value = "Is it validated or not")
  public StateEnum getState() {
    return state;
  }

  public void setState(StateEnum state) {
    this.state = state;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    HarvestSourceValidation harvestSourceValidation = (HarvestSourceValidation) o;
    return Objects.equals(this.by, harvestSourceValidation.by) &&
        Objects.equals(this.comment, harvestSourceValidation.comment) &&
        Objects.equals(this.on, harvestSourceValidation.on) &&
        Objects.equals(this.state, harvestSourceValidation.state);
  }

  @Override
  public int hashCode() {
    return Objects.hash(by, comment, on, state);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class HarvestSourceValidation {\n");

    sb.append("    by: ").append(toIndentedString(by)).append("\n");
    sb.append("    comment: ").append(toIndentedString(comment)).append("\n");
    sb.append("    on: ").append(toIndentedString(on)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

